


/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */


#include <sstmac/common/ptr_type.h>


namespace sstmac {

  ptr_type::~ptr_type()
  {
  }

  ptr_type::ptr_type() : references(0)
  {
  }

  long
  ptr_type::nreferences() const
  {
      return references;
  }

}

#include <sstmac/software/process/operatingsystem.h>
#include <sstmac/hardware/processor/computescheduler.h>
#define track_cls sstmac::sw::operatingsystem

namespace boost {

void intrusive_ptr_add_ref(sstmac::ptr_type * p)
{
   ++(p->references);

   //track_cls* app = dynamic_cast<track_cls*>(p);
   //if (app){
   //    printf("incrementing refcount to %d on track_cls %p!\n",
   //           p->nreferences(), p);
   //}
}

void intrusive_ptr_release(sstmac::ptr_type * p)
{
    //track_cls* app = dynamic_cast<track_cls*>(p);
    //if (app){
    //    printf("decrementing refcount to %d on track_cls %p!\n",
    //           p->nreferences() - 1, p);
    //}

  // decrement reference count, and delete object when reference count reaches 0
  if (--(p->references) == 0){
      delete p;
  }
}

void intrusive_ptr_add_ref(const sstmac::ptr_type * p)
{
  ++(p->references);
}

void intrusive_ptr_release(const sstmac::ptr_type * p)
{
   if (--(p->references) == 0){
       delete p;
   }
}

}
