
/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/common/sim_parameters.h>
namespace sstmac {
  debug sim_parameters::dbg_;

  sim_parameters::ptr sstmac_env::params = 0;

  void
  sim_parameters::get_vector_param(const std::string& key, std::vector<int>& vals)
  {
      std::deque<std::string> tok;
      std::string space = " ";
      pst::BasicStringTokenizer::tokenize(key, tok, space);
      std::deque<std::string>::const_iterator it, end = tok.end();
      for (it = tok.begin(); it != end; ++it)
      {
          std::string core = *it;
          vals.push_back(atoi(core.c_str()));
      }
  }

}
