#include <sstmac/software/libraries/mpi/mpi_protocol/mpiprotocol.h>
#include <sstmac/software/libraries/mpi/mpiserver.h>

namespace sstmac {
    namespace sw {



    void
    eager0_mmap::send_header(const mpiqueue::ptr &queue, const mpimessage::ptr &msg)
    {
        if (queue->server()->get_os()->get_current_threadid() == -1) //this is from the mpi server
        {
            queue->server()->buffered_send(msg);
        }
        else
        {
            queue->user_lib_mem()->read(msg->get_byte_length());
            queue->server()->send(msg);
        }
        SSTMAC_DEBUG << "mpiqueue[" << queue->id_string()
              << "]:: send_eager0_mmap_header done \n";
    }

    void
    eager0_mmap::handle_header(const mpiqueue::ptr &queue, const mpimessage::ptr &msg)
    {
        SSTMAC_DEBUG << "mpiqueue[" << queue->id_string()
              << "]: start mmap eager handle header\n";
        mpiqueue::recvrequest::ptr req = queue->find_pending_request(msg);
        if (req)
            queue->server()->buffered_recv(msg, req);
        queue->notify_probes(msg);
    }

    }
}
