#include <sstmac/software/services/service.h>
#include <sstmac/software/process/operatingsystem.h>


namespace sstmac {
    namespace sw {

    service::service()
    {
      wait_ = waiter::construct();

      init_handler(ptr(this));
      init_waiter(wait_);
    }

    service::~service(){

    }

    void
    service::unregister_all_libs()
    {
        //clear self-reference
        init_handler(eventhandler::ptr());
        library::unregister_all_libs();
    }

    bool
    service::is_app_init(appid aid)
    {
      return (fullos_->env_.find(aid) == fullos_->env_.end());
    }

    void
    service::init_full_os(const boost::intrusive_ptr<operatingsystem> &o)
    {
      fullos_ = o;
    }

    }
}

